// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorStateInformation.idl
// generated code does not contain a copyright notice
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_state_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__init(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(msg);
    return false;
  }
  // lgp_version
  // sensor_state
  // customer_version
  // internal_version
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // lgp_version
  // sensor_state
  // customer_version
  // internal_version
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__are_equal(const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * lhs, const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // lgp_version
  if (lhs->lgp_version != rhs->lgp_version) {
    return false;
  }
  // sensor_state
  if (lhs->sensor_state != rhs->sensor_state) {
    return false;
  }
  // customer_version
  if (lhs->customer_version != rhs->customer_version) {
    return false;
  }
  // internal_version
  for (size_t i = 0; i < 5; ++i) {
    if (lhs->internal_version[i] != rhs->internal_version[i]) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__copy(
  const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * input,
  off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // lgp_version
  output->lgp_version = input->lgp_version;
  // sensor_state
  output->sensor_state = input->sensor_state;
  // customer_version
  output->customer_version = input->customer_version;
  // internal_version
  for (size_t i = 0; i < 5; ++i) {
    output->internal_version[i] = input->internal_version[i];
  }
  return true;
}

off_highway_premium_radar_sample_msgs__msg__SensorStateInformation *
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * msg = (off_highway_premium_radar_sample_msgs__msg__SensorStateInformation *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation));
  bool success = off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__destroy(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__init(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * data = NULL;

  if (size) {
    data = (off_highway_premium_radar_sample_msgs__msg__SensorStateInformation *)allocator.zero_allocate(size, sizeof(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__fini(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence *
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * array = (off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__destroy(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * lhs, const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * input,
  off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_premium_radar_sample_msgs__msg__SensorStateInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_premium_radar_sample_msgs__msg__SensorStateInformation * data =
      (off_highway_premium_radar_sample_msgs__msg__SensorStateInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__SensorStateInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
