// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:srv/SensorModeRequest.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__SENSOR_MODE_REQUEST__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__SENSOR_MODE_REQUEST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Request __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Request __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SensorModeRequest_Request_
{
  using Type = SensorModeRequest_Request_<ContainerAllocator>;

  explicit SensorModeRequest_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->radar_mode = 0;
    }
  }

  explicit SensorModeRequest_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->radar_mode = 0;
    }
  }

  // field types and members
  using _radar_mode_type =
    uint8_t;
  _radar_mode_type radar_mode;

  // setters for named parameter idiom
  Type & set__radar_mode(
    const uint8_t & _arg)
  {
    this->radar_mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MODE_START_MODULATION =
    1u;
  static constexpr uint8_t MODE_STOP_MODULATION =
    2u;

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Request
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Request
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorModeRequest_Request_ & other) const
  {
    if (this->radar_mode != other.radar_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorModeRequest_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorModeRequest_Request_

// alias to use template instance with default allocator
using SensorModeRequest_Request =
  off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SensorModeRequest_Request_<ContainerAllocator>::MODE_START_MODULATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SensorModeRequest_Request_<ContainerAllocator>::MODE_STOP_MODULATION;
#endif  // __cplusplus < 201703L

}  // namespace srv

}  // namespace off_highway_premium_radar_sample_msgs


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Response __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Response __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SensorModeRequest_Response_
{
  using Type = SensorModeRequest_Response_<ContainerAllocator>;

  explicit SensorModeRequest_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit SensorModeRequest_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Response
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__srv__SensorModeRequest_Response
    std::shared_ptr<off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorModeRequest_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorModeRequest_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorModeRequest_Response_

// alias to use template instance with default allocator
using SensorModeRequest_Response =
  off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace off_highway_premium_radar_sample_msgs

namespace off_highway_premium_radar_sample_msgs
{

namespace srv
{

struct SensorModeRequest
{
  using Request = off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Request;
  using Response = off_highway_premium_radar_sample_msgs::srv::SensorModeRequest_Response;
};

}  // namespace srv

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__SENSOR_MODE_REQUEST__STRUCT_HPP_
