// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributes.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'location_attributes_header'
#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_header__struct.hpp"
// Member 'location_attributes_packet'
#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_packet__struct.hpp"
// Member 'mounting_pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributes __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributes __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LocationAttributes_
{
  using Type = LocationAttributes_<ContainerAllocator>;

  explicit LocationAttributes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    location_attributes_header(_init),
    location_attributes_packet(_init),
    mounting_pose(_init)
  {
    (void)_init;
  }

  explicit LocationAttributes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    location_attributes_header(_alloc, _init),
    location_attributes_packet(_alloc, _init),
    mounting_pose(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _location_attributes_header_type =
    off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>;
  _location_attributes_header_type location_attributes_header;
  using _location_attributes_packet_type =
    off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator>;
  _location_attributes_packet_type location_attributes_packet;
  using _mounting_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _mounting_pose_type mounting_pose;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__location_attributes_header(
    const off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> & _arg)
  {
    this->location_attributes_header = _arg;
    return *this;
  }
  Type & set__location_attributes_packet(
    const off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket_<ContainerAllocator> & _arg)
  {
    this->location_attributes_packet = _arg;
    return *this;
  }
  Type & set__mounting_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->mounting_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributes
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributes
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LocationAttributes_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->location_attributes_header != other.location_attributes_header) {
      return false;
    }
    if (this->location_attributes_packet != other.location_attributes_packet) {
      return false;
    }
    if (this->mounting_pose != other.mounting_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const LocationAttributes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LocationAttributes_

// alias to use template instance with default allocator
using LocationAttributes =
  off_highway_premium_radar_sample_msgs::msg::LocationAttributes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES__STRUCT_HPP_
