// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from off_highway_premium_radar_sample_msgs:srv/MeasurementProgram.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__MEASUREMENT_PROGRAM__FUNCTIONS_H_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__MEASUREMENT_PROGRAM__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "off_highway_premium_radar_sample_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "off_highway_premium_radar_sample_msgs/srv/detail/measurement_program__struct.h"

/// Initialize srv/MeasurementProgram message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request
 * )) before or use
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__init(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * msg);

/// Finalize srv/MeasurementProgram message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__fini(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * msg);

/// Create srv/MeasurementProgram message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request *
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__create();

/// Destroy srv/MeasurementProgram message.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__destroy(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * msg);

/// Check for srv/MeasurementProgram message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__are_equal(const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * lhs, const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * rhs);

/// Copy a srv/MeasurementProgram message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__copy(
  const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * input,
  off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request * output);

/// Initialize array of srv/MeasurementProgram messages.
/**
 * It allocates the memory for the number of elements and calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__init(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * array, size_t size);

/// Finalize array of srv/MeasurementProgram messages.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__fini(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * array);

/// Create array of srv/MeasurementProgram messages.
/**
 * It allocates the memory for the array and calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence *
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__create(size_t size);

/// Destroy array of srv/MeasurementProgram messages.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__destroy(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * array);

/// Check for srv/MeasurementProgram message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * lhs, const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * rhs);

/// Copy an array of srv/MeasurementProgram messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * input,
  off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Request__Sequence * output);

/// Initialize srv/MeasurementProgram message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response
 * )) before or use
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__init(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * msg);

/// Finalize srv/MeasurementProgram message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__fini(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * msg);

/// Create srv/MeasurementProgram message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response *
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__create();

/// Destroy srv/MeasurementProgram message.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__destroy(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * msg);

/// Check for srv/MeasurementProgram message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__are_equal(const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * lhs, const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * rhs);

/// Copy a srv/MeasurementProgram message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__copy(
  const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * input,
  off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response * output);

/// Initialize array of srv/MeasurementProgram messages.
/**
 * It allocates the memory for the number of elements and calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__init(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * array, size_t size);

/// Finalize array of srv/MeasurementProgram messages.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__fini(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * array);

/// Create array of srv/MeasurementProgram messages.
/**
 * It allocates the memory for the array and calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence *
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__create(size_t size);

/// Destroy array of srv/MeasurementProgram messages.
/**
 * It calls
 * off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
void
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__destroy(off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * array);

/// Check for srv/MeasurementProgram message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * lhs, const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * rhs);

/// Copy an array of srv/MeasurementProgram messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_off_highway_premium_radar_sample_msgs
bool
off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * input,
  off_highway_premium_radar_sample_msgs__srv__MeasurementProgram_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__SRV__DETAIL__MEASUREMENT_PROGRAM__FUNCTIONS_H_
